{

                                                      ͻ
                                                         PTUI  Demo     
                                                                        
                                                          Rev. 1.00     
                                                      ͼ

}

Program Demo;

{$F-} {$O-} {$A+} {$G-}
{$V-} {$B-} {$X-} {$N+} {$E+}

{$I FINAL.PAS}

{$IFDEF FINAL}
  {$I-} {$R-}

  {$IFDEF VER70}
    {$Q-} {$P-}
  {$ENDIF}

  {$D-} {$L-} {$S-}
  {$M 8192,262144,655360}
{$ELSE}
  {$M 8192,0,655360}
{$ENDIF}

Uses CRT,Strings,PTUI,PTUIVCRT,KeyDef;

Procedure BusyExample;

Var
  Pop   :TextWindow;
  X     :Word;

Begin
  Pop.Open(44,5,72,11,White,LightGrey,Black,Black,NoLine,Solid);
  {Open a Window, Solid Colour, No Line}
  Pop.NewHeading('Working',CentreText,White,Green);
  {Use the heading 'Working', centre the white on green text}
  Pop.Lock;
  {Use relative coordinates, GotoXY(1,1) is now (44,5)}
  VideoColor(White,LightGrey);
  GotoXY(10,4);
  WriteStr('Not Really');
  {Display message in window - Notice, WriteStr instead of Write}

  For X:=1 to 366 do         {Our scale is 0 to 366}
  Begin
    Barometer(3,6,25,#219,X,366);       {Draw updated barometer}
    Delay(10);                          {Pretend to do something}
  End;

  Pop.UnLock;
  {Must do this - Reset coordinates}
  Pop.Close;
  {Must do this - release memory from heap}
End;

Var
  Win       :Array [1..2] of TextWindow;                 {2 Windows}
  WinBut    :Array [1..2] of Array [1..7] of Word;       {2x7 Buttons}
  NewSlide  :SlideBarInfo;                               {A Slide Bar Info}
  DelBut,
  ActiveWin :Byte;
  St        :String;

  MX,MY     :Word;
  MB        :Byte;
  Held,
  Doubled,
  Special   :Boolean;
  Key       :Char;

  SmoothX,
  SmoothY   :Byte;

  TestGet,
  Param     :String;

Begin
  If ParamCount>0 Then
    UpperCase(ParamStr(1),Param)
  Else
    Param:='';

  If Pos('?',Param)>0 Then
  Begin
    WriteLn('Use /C for CGA, /E for EGA or /V for VGA.  /V is the default.');
    WriteLn('If you have a mono card, this will be detected automatically.');
    WriteLn;
    WriteLn('If you have a TSeng Super VGA, use /S.  Other Super VGA''s: See Docs.');
    Halt;
  End;

  If (Card=ColorCard) Then
  Begin
    If Pos('/E',Param)>0 Then                           {EGA?}
    Begin
      VideoCard[ColorCard].CharacterHeight:=14;         {Set Character Size}
      EnableVScreen(EGA);
      VideoCard[Card].ScrollMethod:=ScrollMethod3;      {EGA Scroll}
    End;
    If (Pos('/V',Param)>0) Or (Param='') Then           {VGA?}
      EnableVScreen(VGA);
    If Pos('/S',Param)>0 Then                           {SVGA?}
    Begin
      VideoCard[Card].CardType:=SVGA;

      {***********************************************************}

                    { Put your SVGA mode number below}

      {***********************************************************}

      TextMode($26,0,0,0);

      {***********************************************************}

      EnableVScreen(SVGA);
      VideoCard[Card].ScrollMethod:=ScrollMethod2;      {SVGA Scroll}
    End;
    If Pos('/C',Param)=0 Then
      SetVirtualScreen(160,70);                         {Nice big screen}
  End;

  TestGet:='';
  PushCursorSize;               {Save the DOS cursor Size}
  CursorSize($20,$20);          {Kill the cursor (fails on old VGA's)}
  Cursor:=False;                {Don't update cursor position - save time}
  Mouse.Init(True);             {Check for a Mouse}
  InstallVScreenMouse;          {Install Internal Mouse Driver}
  TextBackground(Blue);
  TextColor(Yellow);
  ClrScr;                       {We've set everything up now, Clear Screen}
  GotoXY(2,2);
  WriteStr(#7+' Click here to exit or press [Esc] to exit.');
  GotoXY(4,3);
  WriteStr('Swap between windows with Right Mouse Button or [Tab].  [E] tests the string editor.');
  GotoXY(4,4);
  WriteStr('Mouse users can drag the window by holding on to the heading and moving the mouse.');
  GotoXY(4,5);
  WriteStr('Keyboard users (no mouse) can use [Ctrl][F5] and the cursor keys, followed by [Return].');
  GotoXY(4,6);
  WriteStr('Use the mouse or [Ctrl][PgUp] [PgDn] [Left] [Right] to scroll across the VGA virtual screen.');

  Window(40,10,130,30);
  WriteStrLn('                                       ');
  WriteStrLn('                     ');
  WriteStrLn('                               ');
  WriteStrLn('                                    ');
  WriteStrLn('                                      ');
  WriteStrLn('                                ');
  WriteStrLn('                                  ');
  Window(1,1,VideoCard[Card].XSize,VideoCard[Card].YSize);

  SmoothX:=VideoCard[ColorCard].CharacterLength Div 8;
  SmoothY:=VideoCard[ColorCard].CharacterHeight Div 8;

  {Work out how many pixels to smooth scroll}

  DelBut:=1;    {Smooth Scroll Temp Variable}
  While (DelBut<30) And (Not KeyPressed) do
  Begin
    Inc(DelBut);

    If Not KeyPressed Then
    Begin

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*3,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*5,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*7,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);
    End;

    ScreenOrigin((VideoCard[Card].SX1) * VideoCard[Card].CharacterLength,
                 (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

    {The lazy man's ^KC smooth scroll  ;-)}

  End;

  ScreenOrigin(0,0);

  Win[1].Open(10,10,50,20,Yellow,Green,Blue,Magenta,NoLine,Solid);
  Win[1].NewHeading('Window 1',CentreText,Yellow,Red);
  Win[1].HeadingIcon(True);  {Make the heading a button to drag window}

  NewSlide.X1:=48;
  NewSlide.Y1:=13;
  NewSlide.X2:=48;              {Setup information for our vertical slide bar}
  NewSlide.Y2:=19;
  NewSlide.Forg:=Yellow;
  NewSlide.Back:=Green;
  NewSlide.MainChar:='';
  NewSlide.ButtonChar:='';
  NewSlide.UpLeftChar:=#$18;
  NewSlide.DownRightChar:=#$19;
  NewSlide.CurPos:=0;
  NewSlide.MaxPos:=99;

  Win[1].VertSlideBar(NewSlide);        {Activate the slide bar}

  NewSlide.X1:=12;
  NewSlide.Y1:=19;
  NewSlide.X2:=47;
  NewSlide.Y2:=19;                      {More exciting information}
  NewSlide.UpLeftChar:=#$1B;
  NewSlide.DownRightChar:=#$1A;

  Win[1].HorzSlideBar(NewSlide);        {Setup the Horizontal Slide Bar}

  Win[1].VertSlideIcon(True);           {Turn the Slide Bars into Buttons}
  Win[1].HorzSlideIcon(True);


  {Okay, this part is done the 'easy' way.  I could setup a linked list
   of buttons and check for them but rather I'm going to add them to
   each window.}

  Win[1].Buttons.Add(2,2,2,2,False,#27);  {Add the Close Application Button, [Esc]=#27}
  WinBut[1][1]:=Win[1].Buttons.Number;    {Remember the button number}
  Win[1].Buttons.Add(0,0,0,0,False,#9);   {0,0,0,0 for Key PressOnly, No Mouse Equivalent}
  WinBut[1][2]:=Win[1].Buttons.Number;    {These are allocated 'randomly'}
  Win[1].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_Right),KeyCode(Key_Ctrl,Key_Right));
  WinBut[1][3]:=Win[1].Buttons.Number;
  Win[1].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_Left) ,KeyCode(Key_Ctrl,Key_Left));
  WinBut[1][4]:=Win[1].Buttons.Number;
  Win[1].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_PgUp) ,KeyCode(Key_Ctrl,Key_PgUp));
  WinBut[1][5]:=Win[1].Buttons.Number;
  Win[1].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_PgDn) ,KeyCode(Key_Ctrl,Key_PgDn));
  WinBut[1][6]:=Win[1].Buttons.Number;

  {We now do the same and open a second window}

  Win[2].Open(15,15,60,23,Green,LightGrey,Blue,Red,NoLine,Solid);
  Win[2].NewHeading('Window 2',CentreText,Blue,Green);
  Win[2].HeadingIcon(True);

  Win[2].Lock;
  VideoColor(Black,LightGrey);
  GotoXY(16,6);
  WriteStr('PTUI Demo Program');
  Win[2].UnLock;

  Win[2].Buttons.Add(2,2,2,2,False,#27);
  WinBut[2][1]:=Win[2].Buttons.Number;
  Win[2].Buttons.Add(0,0,0,0,False,#9);
  WinBut[2][2]:=Win[2].Buttons.Number;
  Win[2].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_Right),KeyCode(Key_Ctrl,Key_Right));
  WinBut[2][3]:=Win[2].Buttons.Number;
  Win[2].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_Left) ,KeyCode(Key_Ctrl,Key_Left));
  WinBut[2][4]:=Win[2].Buttons.Number;
  Win[2].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_PgUp) ,KeyCode(Key_Ctrl,Key_PgUp));
  WinBut[2][5]:=Win[2].Buttons.Number;
  Win[2].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_PgDn) ,KeyCode(Key_Ctrl,Key_PgDn));
  WinBut[2][6]:=Win[2].Buttons.Number;
  Win[2].Buttons.Add(0,0,0,0,False,'E');
  WinBut[2][7]:=Win[2].Buttons.Number;

  BusyExample;  {Demo the Barometer}

  Mouse.Show;   {Show the mouse - can only show it while we are not}
                {writing to the screen}

  ActiveWin:=2; {Let's start with window 2}

  Repeat
    Win[ActiveWin].Buttons.WaitForClick(MX,MY,MB,Held,Doubled,Special,Key);

    {Wait for the user to click on one of the buttons in the active window}

    If (MB=MouseRightButton) Or ((Key=#9) And (Not Special)) Then
         {If the right button or tab was pressed}
    Begin
      If ActiveWin=1 Then
      Begin
        Win[1].Hide;
        Win[2].Hide;
        Win[1].Show;
        Win[2].Show;
        ActiveWin:=2;
      End
      Else
      Begin
        Win[2].Hide;     {Hide the window on top}
        Win[1].Hide;     {Hide the last window}
        Win[2].Show;     {Show the second window}
        Win[1].Show;     {Now the first one is on top}
        ActiveWin:=1;
      End;
    End;

    {If user selects the [Ctrl][Right] key and is not at the end of
     the screen}

    If (Special=SpecialCode(Key_Ctrl,Key_Right)) And
       (Key=KeyCode(Key_Ctrl,Key_Right)) And
       (VideoCard[Card].SX2<VideoCard[Card].XSize) Then
    Begin
      If Not KeyPressed Then
      Begin

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*3,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*5,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*7,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);
      End;

      ScreenOrigin((VideoCard[Card].SX1) * VideoCard[Card].CharacterLength,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

      {The lazy man's ^KC smooth scroll  ;-)}

    End;

    {Check for [Ctrl][Left]}

    If (Special=SpecialCode(Key_Ctrl,Key_Left)) And
       (Key=KeyCode(Key_Ctrl,Key_Left)) And
       (VideoCard[Card].SX1>1) Then
    Begin
      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength - SmoothX,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

      If Not KeyPressed Then
      Begin

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*5,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX*3,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength + SmoothX,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);

      End;

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);
    End;

    {Check for [Ctrl][PgDn - There is NO [Ctrl][Down] in Pascal}

    If (Special=SpecialCode(Key_Ctrl,Key_PgDn)) And
       (Key=KeyCode(Key_Ctrl,Key_PgDn)) And
       (VideoCard[Card].SY2<VideoCard[Card].YSize) Then
    Begin
      If Not KeyPressed Then
      Begin

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY*3);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY*5);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY*7);
      End;

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                   (VideoCard[Card].SY1) * VideoCard[Card].CharacterHeight);
    End;

    {[Ctrl][PgUp]}

    If (Special=SpecialCode(Key_Ctrl,Key_PgUp)) And
       (Key=KeyCode(Key_Ctrl,Key_PgUp)) And
       (VideoCard[Card].SY1>1) Then
    Begin
      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight - SmoothY);

      If Not KeyPressed Then
      Begin

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY*5);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY*3);

        ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                     (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight + SmoothY);

      End;

      ScreenOrigin((VideoCard[Card].SX1 - 1) * VideoCard[Card].CharacterLength,
                   (VideoCard[Card].SY1 - 1) * VideoCard[Card].CharacterHeight);
    End;

    If (Special=SpecialCode(Key_Ctrl, Key_F5)) And
       (Key=KeyCode(Key_Ctrl, Key_F5)) Then
    Begin

      {We have to delete buttons that we don't want moved if the
       user drags the window - remember - some of the defined buttons
       were not in the window - we must remove them.}

      For DelBut:=1 to 6 do
      Begin
        Win[ActiveWin].Buttons.GotoNumber(WinBut[ActiveWin][DelBut]);
        Win[ActiveWin].Buttons.KillOne;
      End;
      If ActiveWin=2 Then       {This window has 7 Buttons}
      Begin
        Win[ActiveWin].Buttons.GotoNumber(WinBut[ActiveWin][DelBut]);
        Win[ActiveWin].Buttons.KillOne;
      End;

      Win[ActiveWin].Drag;

      {Now we can add the buttons back to the windows}

      Win[ActiveWin].Buttons.Add(2,2,2,2,False,#27);
      WinBut[ActiveWin][1]:=Win[ActiveWin].Buttons.Number;
      Win[ActiveWin].Buttons.Add(0,0,0,0,False,#9);
      WinBut[ActiveWin][2]:=Win[ActiveWin].Buttons.Number;
      Win[ActiveWin].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_Right),KeyCode(Key_Ctrl,Key_Right));
      WinBut[ActiveWin][3]:=Win[ActiveWin].Buttons.Number;
      Win[ActiveWin].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_Left) ,KeyCode(Key_Ctrl,Key_Left));
      WinBut[ActiveWin][4]:=Win[ActiveWin].Buttons.Number;
      Win[ActiveWin].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_PgUp) ,KeyCode(Key_Ctrl,Key_PgUp));
      WinBut[ActiveWin][5]:=Win[ActiveWin].Buttons.Number;
      Win[ActiveWin].Buttons.Add(0,0,0,0,SpecialCode(Key_Ctrl,Key_PgDn) ,KeyCode(Key_Ctrl,Key_PgDn));
      WinBut[ActiveWin][6]:=Win[ActiveWin].Buttons.Number;

      If ActiveWin=2 Then
      Begin
        Win[ActiveWin].Buttons.Add(0,0,0,0,False,'E');
        WinBut[ActiveWin][7]:=Win[ActiveWin].Buttons.Number;
      End;

    End;

    If (ActiveWin=2) And (Not Special) And (UpCase(Key)='E') Then
    Begin
      Mouse.Hide;
      Win[ActiveWin].Lock;
      VideoColor(14,7);
      EditStr(15,4,20,False,TestGet);
      Win[ActiveWin].UnLock;
      Mouse.Show;
    End;

    If ActiveWin=1 Then    {Window 1 has Slide Bars - Check for Them}
    Begin

      If Held And (Special=SpecialCode(Mouse_Only, Mouse_SlideButtonVert)) And
                  (Key=KeyCode(Mouse_Only, Mouse_SlideButtonVert)) Then Win[ActiveWin].DragVertSlideButton;

      If Held And (Special=SpecialCode(Mouse_Only, Mouse_SlideButtonHorz)) And
                  (Key=KeyCode(Mouse_Only, Mouse_SlideButtonHorz)) Then Win[ActiveWin].DragHorzSlideButton;

      If (Special=SpecialCode(Mouse_Only, Mouse_SlideBarVert)) And
         (Key=KeyCode(Mouse_Only, Mouse_SlideBarVert)) Then Win[ActiveWin].DragVertSlideButton;

      If (Special=SpecialCode(Mouse_Only, Mouse_SlideBarHorz)) And
         (Key=KeyCode(Mouse_Only, Mouse_SlideBarHorz)) Then Win[ActiveWin].DragHorzSlideButton;

      If (Special=SpecialCode(Key_None, Key_Up)) And
         (Key=KeyCode(Key_None, Key_Up)) And (Win[ActiveWin].VSlide.CurPos>0)
      Then
        Win[ActiveWin].UpdateVertSlideBar(Win[ActiveWin].VSlide.CurPos-1);

      If (Special=SpecialCode(Key_None, Key_Down)) And
         (Key=KeyCode(Key_None, Key_Down)) And (Win[ActiveWin].VSlide.CurPos<99)
      Then
        Win[ActiveWin].UpdateVertSlideBar(Win[ActiveWin].VSlide.CurPos+1);

      If (Special=SpecialCode(Key_None, Key_Right)) And
         (Key=KeyCode(Key_None, Key_Right)) And (Win[ActiveWin].HSlide.CurPos<99)
      Then
        Win[ActiveWin].UpdateHorzSlideBar(Win[ActiveWin].HSlide.CurPos+1);

      If (Special=SpecialCode(Key_None, Key_Left)) And
         (Key=KeyCode(Key_None, Key_Left)) And (Win[ActiveWin].HSlide.CurPos>0)
      Then
        Win[ActiveWin].UpdateHorzSlideBar(Win[ActiveWin].HSlide.CurPos-1);

    End;

    If ActiveWin=1 Then
    Begin
      Mouse.Hide;                      {Hide mouse - we want to write to screen}
      Win[1].Lock;
      VideoColor(Blue,Green);
      GotoXY(5,5);                     {Relative}
      Str(Win[1].VSlide.CurPos+1,St);
      WriteStr('Line  : '+St+'  ');    {Update window information}
      GotoXY(5,7);
      Str(Win[1].HSlide.CurPos+1,St);
      WriteStr('Column: '+St+'  ');
      Win[1].UnLock;
      Mouse.Show;                      {Show mouse again}
    End;

  Until ((MX=2) And (MY=2)) Or (Key=#27);    {Exit Command}
  PopCursorSize;                             {Restore Cursor Size}
                                             {To be polite, you should here
                                              call SetVitualSceen, ScreenOrigin and
                                              ClrScr}
End.
